import { GraphQLResolveInfo } from "graphql";
export interface ComponentClass<TSource = any, TArgs = any, TContext = any> {
    new (source: TSource, args: TArgs, context: TContext, info: GraphQLResolveInfo): Component<TSource, TArgs, TContext>;
}
/**
 * Class-based resolver context
 */
export declare class Component<TSource = {
    [key: string]: any;
}, TArgs = {}, TContext = {}> {
    $env: IArguments;
    readonly $source: TSource;
    readonly $args: TArgs;
    readonly $context: TContext;
    readonly $info: GraphQLResolveInfo;
    constructor(source: TSource, args?: TArgs, context?: TContext, info?: GraphQLResolveInfo);
}
