"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Decorator for fields resolved from source directly
 * @param fieldName
 */
function source(fieldName) {
    return function (prototype, propertyKey) {
        var get = function () {
            return this.$source[fieldName || propertyKey];
        };
        Object.defineProperty(prototype, propertyKey, { get: get });
    };
}
exports.source = source;
/**
 * Decorator for field resolved after async fetching
 * prototype should have `$fetch()` method which returns a Promise
 * @param fieldName
 */
function async(fieldName) {
    return function (prototype, propertyKey) {
        var get = function () {
            if (!this.$__fetcher__) {
                this.$__fetcher__ = this.$fetch();
            }
            return this.$__fetcher__.then(function (remoteSource) { return remoteSource[fieldName || propertyKey]; });
        };
        Object.defineProperty(prototype, propertyKey, { get: get });
    };
}
exports.async = async;
//# sourceMappingURL=decorators.js.map