import { GraphQLFieldConfigArgumentMap, GraphQLOutputType, GraphQLFieldResolver } from "graphql";
import { TypeExpression } from "../type-expression/TypeExpression";
import { MetadataStorage } from "../base/MetadataStorage";
import { InputField } from "./InputField";
export interface FieldConfig {
    defaultName: string;
    type: TypeExpression;
    args: InputField[];
    description?: string;
    deprecationReason?: string;
    directives?: any;
}
export declare class Field<TConfig extends FieldConfig = FieldConfig> {
    protected config: TConfig;
    constructor(config: TConfig);
    readonly defaultName: string;
    readonly description: string | undefined;
    readonly deprecationReason: string | undefined;
    buildArgs(storage: MetadataStorage, targetClass?: Function): GraphQLFieldConfigArgumentMap;
    buildType(storage: MetadataStorage, targetClass?: Function): GraphQLOutputType;
}
export declare class FieldMount {
    field: Field;
    mountName: string;
    resolver?: GraphQLFieldResolver<any, any>;
    constructor(values: FieldMount);
}
