import { GraphQLInputType } from "graphql";
import { TypeExpression, MetadataStorage } from "..";
export interface InputFieldConfig {
    type: TypeExpression;
    defaultName: string;
    defaultValue?: any;
    description?: string;
    directives?: any;
}
export declare class InputField<TConfig extends InputFieldConfig = InputFieldConfig> {
    protected config: TConfig;
    constructor(config: TConfig);
    readonly defaultName: string;
    readonly defaultValue: any;
    readonly description: string | undefined;
    readonly directives: any;
    buildType(storage: MetadataStorage, targetClass?: Function): GraphQLInputType;
}
