import { MetadataStorage } from "./base/MetadataStorage";
import { TypeArg } from "./type-expression/TypeExpression";
import { FieldMount } from "./field";
export declare function createMetadataStorage(): MetadataStorage;
/**
 * Global MetadataStorage used by default.
 */
export declare let globalMetadataStorage: MetadataStorage;
export declare function getGlobalMetadataStorage(): MetadataStorage;
/**
 * Get a GraphQLType instance from the given storage or default
 * global metadata storage.
 * @param typeArg
 * @param storage
 */
export declare function getGraphQLType(typeArg: TypeArg, maybeStorage?: MetadataStorage): any;
export declare function mountField(resolver: any, asName?: string, maybeStorage?: MetadataStorage): FieldMount;
