import { GraphQLInputObjectType, GraphQLInputFieldConfigMap, GraphQLInputFieldConfig } from "graphql";
import { Definition, DefinitionConfig } from "../base/Definition";
import { MetadataStorage, InputFieldReferenceEntry } from "../base/MetadataStorage";
import { ASTParser } from "../sdl/ast";
export interface InputTypeConfig extends DefinitionConfig {
}
/**
 * Metadata type for InputObjectType
 */
export declare class InputType<T extends InputTypeConfig = InputTypeConfig> extends Definition<T> {
    protected static decorate(astParser: ASTParser, storage: MetadataStorage, linkedClass: Function): void;
    buildInputFieldConfig(storage: MetadataStorage, targetClass: Function, entry: InputFieldReferenceEntry): GraphQLInputFieldConfig;
    buildInputFieldConfigMap(storage: MetadataStorage, targetClass: Function): GraphQLInputFieldConfigMap;
    buildTypeInstance(storage: MetadataStorage, targetClass: Function): GraphQLInputObjectType;
}
