"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var Definition_1 = require("../base/Definition");
/**
 * Metadata type for InputObjectType
 */
var InputType = /** @class */ (function (_super) {
    __extends(InputType, _super);
    function InputType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    InputType.decorate = function (astParser, storage, linkedClass) {
        var _this = this;
        _super.decorate.call(this, astParser, storage, linkedClass);
        astParser.inputObjectTypeMetadataConfigs.forEach(function (config) {
            storage.register(new _this(config), linkedClass);
        });
    };
    InputType.prototype.buildInputFieldConfig = function (storage, targetClass, entry) {
        return {
            type: entry.field.buildType(storage, targetClass),
            defaultValue: entry.field.defaultValue,
            description: entry.field.description,
        };
    };
    InputType.prototype.buildInputFieldConfigMap = function (storage, targetClass) {
        var _this = this;
        var inputFieldMetadata = storage.queryInputFieldReference(targetClass);
        return inputFieldMetadata.reduce(function (results, entry) {
            results[entry.field.defaultName] = _this.buildInputFieldConfig(storage, targetClass, entry);
            return results;
        }, {});
    };
    InputType.prototype.buildTypeInstance = function (storage, targetClass) {
        var name = this.typeName;
        var fields = this.buildInputFieldConfigMap.bind(this, storage, targetClass);
        var description = this.description;
        return new graphql_1.GraphQLInputObjectType({ name: name, fields: fields, description: description });
    };
    return InputType;
}(Definition_1.Definition));
exports.InputType = InputType;
//# sourceMappingURL=InputType.js.map