import { GraphQLFieldConfigMap, GraphQLTypeResolver, GraphQLInterfaceType, GraphQLFieldConfig } from "graphql";
import { Definition, DefinitionConfig } from "../base/Definition";
import { MetadataStorage, FieldReferenceEntry } from "../base/MetadataStorage";
import { ASTParser } from "../sdl/ast";
export interface InterfaceTypeConfig extends DefinitionConfig {
    resolveType?: GraphQLTypeResolver<any, any>;
    description?: string;
}
/**
 * Metadata type for InterfaceType
 */
export declare class InterfaceType<T extends InterfaceTypeConfig = InterfaceTypeConfig> extends Definition<T> {
    protected static decorate(astParser: ASTParser, storage: MetadataStorage, linkedClass: Function): void;
    buildFieldConfig(storage: MetadataStorage, targetClass: Function, entry: FieldReferenceEntry): GraphQLFieldConfig<any, any>;
    buildFieldConfigMap(storage: MetadataStorage, targetClass: Function): GraphQLFieldConfigMap<any, any>;
    buildTypeInstance(storage: MetadataStorage, targetClass: Function): GraphQLInterfaceType;
}
