"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var Definition_1 = require("../base/Definition");
/**
 * Metadata type for InterfaceType
 */
var InterfaceType = /** @class */ (function (_super) {
    __extends(InterfaceType, _super);
    function InterfaceType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    InterfaceType.decorate = function (astParser, storage, linkedClass) {
        var _this = this;
        _super.decorate.call(this, astParser, storage, linkedClass);
        astParser.interfaceTypeMetadataConfigs.forEach(function (config) {
            storage.register(new _this(config), linkedClass);
        });
    };
    InterfaceType.prototype.buildFieldConfig = function (storage, targetClass, entry) {
        var _a = entry.field, description = _a.description, deprecationReason = _a.deprecationReason;
        return {
            type: entry.field.buildType(storage, targetClass),
            args: entry.field.buildArgs(storage, targetClass),
            description: description,
            deprecationReason: deprecationReason,
            resolve: entry.resolver,
        };
    };
    InterfaceType.prototype.buildFieldConfigMap = function (storage, targetClass) {
        var _this = this;
        var refs = storage.queryFieldReferences(targetClass);
        return (refs.reduce(function (results, entry) {
            var name = entry.mountName || entry.field.defaultName;
            results[name] = _this.buildFieldConfig(storage, targetClass, entry);
            return results;
        }, {}));
    };
    InterfaceType.prototype.buildTypeInstance = function (storage, targetClass) {
        var name = this.typeName;
        var fields = this.buildFieldConfigMap.bind(this, storage, targetClass);
        var description = this.description;
        return new graphql_1.GraphQLInterfaceType({ name: name, fields: fields, description: description });
    };
    return InterfaceType;
}(Definition_1.Definition));
exports.InterfaceType = InterfaceType;
//# sourceMappingURL=InterfaceType.js.map