import { GraphQLResolveInfo } from "graphql";
export interface ReducerClass<TSource = any, TArgs = any, TContext = any> {
    new (source: TSource, args: TArgs, context: TContext, info: GraphQLResolveInfo): Reducer<TSource, TContext>;
}
/**
 * Class-based resolver context
 */
export declare class Reducer<TSource = undefined, TContext = {}> {
    $env: IArguments;
    readonly $source: TSource;
    readonly $context: TContext;
    readonly $info: GraphQLResolveInfo;
    constructor(_base?: TSource, _context?: TContext, _info?: GraphQLResolveInfo);
}
