import { GraphQLType } from "graphql";
import { MetadataStorage, DefinitionEntry } from "../base/MetadataStorage";
import { Lazy } from "../types";
export declare type TypeArg = GraphQLType | string | Function;
/**
 * Contain an argument which can be resolved to GraphQLType instance.
 */
export declare class TypeExpression {
    constructor(typeOption: TypeArg | Lazy<TypeArg> | TypeExpression | Lazy<TypeExpression>);
    resolve(targetClass?: Function): TypeExpression;
    typeArg: TypeArg | Lazy<TypeArg> | TypeExpression | Lazy<TypeExpression>;
    protected getDefinitionEntry(storage: MetadataStorage): DefinitionEntry;
    buildTypeInstance(storage: MetadataStorage, targetClass?: Function): GraphQLType;
}
