import { TypeExpression, TypeArg } from "./TypeExpression";
import { GraphQLType } from "graphql";
import { MetadataStorage } from "../base/MetadataStorage";
import { ConcreteClass } from "../types";
export declare abstract class Structure extends TypeExpression {
    static of<T extends Structure>(this: ConcreteClass<T>, innerType: TypeExpression | TypeArg): T;
    constructor(innerType: TypeExpression);
    innerType: TypeExpression;
}
export declare class List extends Structure {
    buildTypeInstance(storage: MetadataStorage, targetClass?: Function): GraphQLType;
}
export declare class NonNull extends Structure {
    buildTypeInstance(storage: MetadataStorage, targetClass?: Function): GraphQLType;
}
