"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var TypeExpression_1 = require("./TypeExpression");
var graphql_1 = require("graphql");
var Structure = /** @class */ (function (_super) {
    __extends(Structure, _super);
    function Structure(innerType) {
        var _this = _super.call(this, innerType.typeArg) || this;
        _this.innerType = innerType;
        return _this;
    }
    Structure.of = function (innerType) {
        return new this(innerType instanceof TypeExpression_1.TypeExpression ? innerType : new TypeExpression_1.TypeExpression(innerType));
    };
    return Structure;
}(TypeExpression_1.TypeExpression));
exports.Structure = Structure;
var List = /** @class */ (function (_super) {
    __extends(List, _super);
    function List() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    List.prototype.buildTypeInstance = function (storage, targetClass) {
        var innerTypeInstance = _super.prototype.buildTypeInstance.call(this, storage, targetClass);
        return new graphql_1.GraphQLList(innerTypeInstance);
    };
    return List;
}(Structure));
exports.List = List;
var NonNull = /** @class */ (function (_super) {
    __extends(NonNull, _super);
    function NonNull() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NonNull.prototype.buildTypeInstance = function (storage, targetClass) {
        var innerTypeInstance = this.innerType.buildTypeInstance(storage, targetClass);
        return new graphql_1.GraphQLNonNull(innerTypeInstance);
    };
    return NonNull;
}(Structure));
exports.NonNull = NonNull;
//# sourceMappingURL=structure.js.map