export declare type ResolvedValue<T> = T | Promise<T>;
export declare type ResolvedList<T> = T[] | Promise<T[]> | Promise<T>[];
export declare type Lazy<T> = (...args: any[]) => T;
export declare function isLazy<T>(arg: Lazy<T> | any): arg is Lazy<T>;
export declare function isSubClassOf(cls: Function, superClass: Function): boolean;
export interface ConcreteClass<T = any> {
    new (...args: any[]): T;
}
export declare type TypedClassDecorator<T extends Function> = (cls: T) => T | void;
export declare function isPromise<T = any>(value: T | Promise<T>): value is Promise<T>;
